////////////////////////////////////////////////////////////////////////////////
// auls_stereopsis.cpp
// ̎摜o̓vOC
// -----------------------------------------------------------------------------
// ɓ삳ɂ lua51.dll xǂݍ݂Kv܂B
////////////////////////////////////////////////////////////////////////////////

#include <aulslib/generic.h>
#include <aulslib/aviutl.h>
#include <aulslib/exedit.h>
#include <aulslib/lua.h>

using namespace auls;

static const LPSTR FILTER_NAME = "̎摜o";
static const LPSTR FILTER_INFORMATION = "Auls̎摜o";

static const LPSTR FILE_FILTER = "PNGt@C\0*.png\0ׂẴt@C\0*.*\0";

bool g_draw_right; // 
bool (*OutputPng)(LPCSTR, void*, int, int, int);

////////////////////////////////////////////////////////////////////////////////
// 摜o
////////////////////////////////////////////////////////////////////////////////

static bool OutputStereopsis(void *editp, FILTER *fp)
{
	if(!fp->exfunc->is_editing(editp)) return false;
	char filename[MAX_PATH];
	if(!fp->exfunc->dlg_get_save_name(filename, FILE_FILTER, NULL)) return false;
	
	bool ret = false;
	FILTER *exedit = auls::Exedit_GetFilter(fp);
	CMemory<PIXEL> pixel, src;
	int frame = fp->exfunc->get_frame(editp);

	// IIuWFNg͂_߂ func_save_start Ă
	if(exedit) exedit->func_save_start(exedit, frame, frame, editp);

	// 摜f[^擾
	int width, height;
	fp->exfunc->get_pixel_filtered(editp, frame, NULL, &width, &height);
	if(!pixel.Alloc(width*height*2) || !src.Alloc(width*height)) goto finish;

	g_draw_right = false;
	fp->exfunc->get_pixel_filtered(editp, frame, src, NULL, NULL);
	for(int y = 0; y < height; y++) {
		for(int x = 0; x < width; x++) {
			pixel[x + y * width * 2] = src[x + y * width];
		}
	}
	g_draw_right = true;
	fp->exfunc->get_pixel_filtered(editp, frame, src, NULL, NULL);
	for(int y = 0; y < height; y++) {
		for(int x = 0; x < width; x++) {
			pixel[x + width + y * width * 2] = src[x + y * width];
		}
	}
	g_draw_right = false;
	src.Free();

	ret = OutputPng(filename, pixel, width*2, height, sizeof(PIXEL));

finish:
	if(exedit) exedit->func_save_end(exedit, editp);
	return ret;
}

////////////////////////////////////////////////////////////////////////////////
// tB^֐
////////////////////////////////////////////////////////////////////////////////

static BOOL func_init(FILTER *fp)
{
	HWND aviutl_hwnd = GetWindow(fp->hwnd, GW_OWNER);

	FILTER *oppng = auls::AviUtl_GetFilter(fp, "PNGo");
	if(!oppng) {
		MessageBox(aviutl_hwnd, "PNGo̓vOC܂B", FILTER_INFORMATION, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	OutputPng = (bool(*)(LPCSTR, void*, int, int, int))GetProcAddress((HMODULE)oppng->dll_hinst, "OutputPng");
	if(!OutputPng) {
		MessageBox(aviutl_hwnd, "PNGo͊֐擾ł܂B", FILTER_INFORMATION, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	fp->exfunc->add_menu_item(fp, "̎摜o", fp->hwnd, 1, 0, 0);

	return TRUE;
}

static BOOL func_WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp, void *editp, FILTER *fp)
{
	if((msg == WM_COMMAND && LOWORD(wp) == MID_FILTER_BUTTON+0) ||
		(msg == WM_FILTER_COMMAND && LOWORD(wp) == 1)) {
		OutputStereopsis(editp, fp);
	}
	return FALSE;
}

LPSTR check_name[] = { "̎摜o" };
int   check_def[]  = { -1 };

static FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE,
	0, 0,
	FILTER_NAME,
	0, NULL, NULL, NULL, NULL,
	1, check_name, check_def,
	NULL,
	func_init,
	NULL,
	NULL,
	func_WndProc,
	NULL,
	NULL,
	NULL,
	NULL,
	FILTER_INFORMATION,
};

extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}

////////////////////////////////////////////////////////////////////////////////
// Lua֐
////////////////////////////////////////////////////////////////////////////////

int l_draw_right(lua_State *L)
{
	lua_pushboolean(L, g_draw_right ? 1 : 0);
	return 1;
}

luaL_reg table[] = {
	{ "draw_right", l_draw_right },
	{ NULL, NULL },
};

extern "C" __declspec(dllexport) int luaopen_auls_stereopsis(lua_State *L)
{
	auls::luaA_register(L, "auls", "stereopsis", table);
	return 1;
}
